include(ExternalProject)
#cmake_policy(SET CMP0135 NEW)
include(FetchContent)
set(EXTERNALS_DIR ${CMAKE_BINARY_DIR}/_deps)


# Like `FetchContent_MakeAvailable` but passes EXCLUDE_FROM_ALL to `add_subdirectory`.
#macro(FetchContent_MakeAvailableExcludeFromAll)
#    foreach(contentName IN ITEMS ${ARGV})
#        string(TOLOWER ${contentName} contentNameLower)
#        FetchContent_GetProperties(${contentName})
#        if(NOT ${contentNameLower}_POPULATED)
#            FetchContent_Populate(${contentName})
#            if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
#                add_subdirectory(${${contentNameLower}_SOURCE_DIR}
#                    ${${contentNameLower}_BINARY_DIR} EXCLUDE_FROM_ALL)
#            endif()
#        endif()
##    endforeach()
##endmacro()
#
#FetchContent_Declare(zlib
#    URL https://www.zlib.net/zlib-1.3.tar.gz
#        https://www.zlib.net/fossils/zlib-1.3.tar.gz
#        https://github.com/madler/zlib/releases/download/v1.3/zlib-1.3.tar.gz
#    URL_HASH MD5=60373b133d630f74f4a1f94c1185a53f
#)
#
#FetchContent_MakeAvailableExcludeFromAll(zlib)
#
#add_library(ZLIB::ZLIB ALIAS zlibstatic)
#target_include_directories(zlibstatic INTERFACE ${zlib_BINARY_DIR} ${zlib_SOURCE_DIR})
#set(ZLIB_LIBRARIES ZLIB::ZLIB)
#set(ZLIB_INCLUDE_DIRS ${zlib_SOURCE_DIR} ${zlib_BINARY_DIR})

ExternalProject_Add(gstreamer
  # URL                 http://resource.sw-motion.cn/3rdparty/gstreamer-1.24.1-aarch64-static.tar.gz
  URL                 file://${CMAKE_SOURCE_DIR}/build/gstreamer-1.24.1-aarch64-static.tar.gz
  SOURCE_DIR        ${EXTERNALS_DIR}/gstreamer
  CONFIGURE_COMMAND true
  BUILD_COMMAND     true
  INSTALL_COMMAND   true
)

ExternalProject_Add(icu
  # URL                 http://resource.sw-motion.cn/3rdparty/icu-72.1-aarch64-static.tar.gz
  URL                 file://${CMAKE_SOURCE_DIR}/build/icu-72.1-aarch64-static.tar.gz
  SOURCE_DIR        ${EXTERNALS_DIR}/icu
  CONFIGURE_COMMAND true
  BUILD_COMMAND     true
  INSTALL_COMMAND   true
)

set(GSTREAMER_INCLUDE_DIRS 
                    ${EXTERNALS_DIR}/gstreamer/include/gstreamer-1.0
                    ${EXTERNALS_DIR}/gstreamer/include/libsoup-2.4
                    ${EXTERNALS_DIR}/gstreamer/include/glib-2.0
                    ${EXTERNALS_DIR}/gstreamer/include/json-glib-1.0
                    ${EXTERNALS_DIR}/gstreamer/lib/glib-2.0/include
                    ${EXTERNALS_DIR}/gstreamer/include/libsoup-2.4/libsoup
                    ${EXTERNALS_DIR}/gstreamer/include)
set(ICU_INCLUDE_DIRS ${EXTERNALS_DIR}/icu/include)
set(GSTREAMER_LIB_DIRS 
                ${EXTERNALS_DIR}/gstreamer/lib
                ${EXTERNALS_DIR}/gstreamer/lib/gstreamer-1.0
                ${EXTERNALS_DIR}/gstreamer/lib/glib-2.0
                ${EXTERNALS_DIR}/gstreamer/lib/gio/modules)
set(ICU_LIB_DIRS ${EXTERNALS_DIR}/icu/lib)

# set(ENV{PKG_CONFIG_PATH} "${EXTERNALS_DIR}/gstreamer/lib/pkgconfig/:${EXTERNALS_DIR}/installed/lib/gstreamer-1.0/pkgconfig/:${EXTERNALS_DIR}/installed/lib/gio/modules/pkgconfig/")

set(ICUUC_LIBRARIES 
        icuuc.a
        icudata.a)
set(GSTREAMER_LIBRARIES 
        gstreamer-full-1.0
        gstreamer-1.0
        json-glib-1.0
        soup-2.4
        gstsdp-1.0
        gstapp-1.0
        gobject-2.0
        gstrtspserver-1.0
        pangoft2-1.0
        gstapp
        gstadder
        gstcoretracers
        gstaudioconvert
        gstaudiomixer
        gsttcp
        gstvideorate
        gstvideotestsrc
        gstpango
        gstopus
        gstalphacolor
        gstalpha
        gstvorbis
        gstogg
        gstvolume
        gstautodetect
        gstauparse
        gstaudioparsers
        gstaudiofx
        gstapetag
        gstvideoconvertscale
        gsttypefindfunctions
        gstsubparse
        gstrawparse
        gstflv
        gstequalizer
        gsteffectv
        gstdtmf
        gstdeinterlace
        gstdebug
        gstimagefreeze
        gstid3demux
        gsticydemux
        gstgoom2k1
        gstgoom
        gstflxdec
        gstnavigationtest
        gstcutter
        gstavi
        gstplayback
        gstpbtypes
        gstrtp
        gstreplaygain
        gstmultipart
        gstmultifile
        gstmonoscope
        gstaudiorate
        gstaudioresample
        gstaudiotestsrc
        gstcompositor
        gstdsd
        gstbasedebug
        gstencoding
        gstwavparse
        gstwavenc
        gstvideomixer
        gstvideofilter
        gstvideocrop
        gstvideobox
        gstudp
        gstspectrum
        gstsmpte
        gstshapewipe
        gstgio
        gstoverlaycomposition
        gstinterleave
        gstisomp4
        gstalaw
        gstmulaw
        gstlevel
        gstmatroska
        gstrtpmanager
        gstrtsp
        gstxingmux
        gsty4menc
        gstossaudio
        gstoss4
        gstvideo4linux2
        gstadaptivedemux2
        gstcairo
        gstjack
        gstjpeg
        gstlame
        gstdv
        gstpng
        gstnice
        gstaccurip
        gstadpcmdec
        gstadpcmenc
        gstaiff
        gstasfmux
        gstaudiobuffersplit
        gstaudiofxbad
        gstaudiomixmatrix
        gstaudiolatency
        gstaudiovisualizers
        gstautoconvert
        gstbayer
        gstcamerabin
        gstcodecalpha
        gstcodectimestamper
        gstcoloreffects
        gstdebugutilsbad
        gstdvbsubenc
        gstdvbsuboverlay
        gstdvdspu
        gstfaceoverlay
        gstfestival
        gstfieldanalysis
        gstfreeverb
        gstfrei0r
        gstgaudieffects
        gstgdp
        gstgeometrictransform
        gstid3tag
        gstinsertbin
        gstinter
        gstinterlace
        gstivfparse
        gstivtc
        gstjp2kdecimator
        gstjpegformat
        gstrfbsrc
        gstsiren
        gstsegmentclip
        gstsdpelem
        gstrtpmanagerbad
        gstrtmp2
        gstrist
        gstremovesilence
        gstlegacyrawparse
        gstproxy
        gstpnm
        gstpcapparse
        gstrtponvif
        gstnetsim
        gstmxf
        gstmse
        gstmpegtsmux
        gstmpegtsdemux
        gstmpegpsmux
        gstmpegpsdemux
        gstmidi
        gstsmooth
        gstspeed
        gstsubenc
        gstswitchbin
        gsttimecode
        gsttranscode
        gstunixfd
        gstvideofiltersbad
        gstvideoframe_audiolevel
        gstvideoparsersbad
        gstvideosignal
        gstvmnc
        gsty4mdec
        gstaja
        gstdecklink
        gstdvb
        gstfbdevsink
        gstipcpipeline
        gstkms
        # gstqsv
        gstasf
        gstwebrtc
        gstttmlsubs
        gstsrtp
        gstsmoothstreaming
        gstsctp
        gstopusparse
        gstopenjpeg
        gstopenh264
        gstmicrodns
        gsthls
        gstdtls
        gstdash
        gstcodec2json
        gstclosedcaption
        gstbz2
        gstavtp
        gstanalyticsoverlay
        gstaes
        gstshm
        gstdvdlpcmdec
        gstdvdsub
        gstrealmedia
        gstx264
        gstlibav
        gstrtspclientsink
        gstwebrtc-1.0
        gstwebrtcnice-1.0
        gstvideo-1.0
        gstaudio-1.0
        gstbadaudio-1.0
        gstbase-1.0
        gstrtp-1.0
        srtp2
        gstsctp-1.0
        gsturidownloader-1.0
        gstadaptivedemux-1.0
        openjp2
        avtp
        gstanalytics-1.0
        x264
        microdns
        pango-1.0
        cairo
        ogg
        nice
        opus
        openh264
        vorbis
        vorbisfile
        vorbisenc
        gstriff-1.0
        gstmpegts-1.0
        gstallocators-1.0
        gio-2.0
        avcodec
        avformat
        avfilter
        avdevice
        avtp
        avutil
        swresample
        swscale
        postproc
        gstcodecparsers-1.0
        gstaudio-1.0
        gsttag-1.0
        gstsdp-1.0
        gstpbutils-1.0
        gstfft-1.0
        gstrtsp-1.0
        gstnet-1.0
        fontconfig
        freetype
        expat
        fribidi
        harfbuzz
        harfbuzz-gobject
        xml2
        jpeg
        psl
        pixman-1
        cairo-gobject
        pangocairo-1.0
        gstbasecamerabinsrc-1.0
        gstphotography-1.0
        gstinsertbin-1.0
        gstmse-1.0
        drm
        gstva-1.0
        va
        va-drm
        mp3lame
        dv
        png16
        bz2
        gstcoreelements
        pcre2-8
        ffi
        m
        dl
        gio-2.0
        gioopenssl.a
        gioenvironmentproxy.a
        gmodule-2.0
        glib-2.0)