find_program(FIND_CMD find)
if ("${FIND_CMD}" STREQUAL "")
    set(FIND_CMD "find")
endif()

#find and set toolchain automatically
function(set_toolchain)
    if(NOT "${CMAKE_TOOLCHAIN_FILE}" MATCHES ".*toolchain\.cmake")
        set(SEARCH_PATH "/usr" "/opt" "/home" "/root")
        foreach(SP ${SEARCH_PATH})
            execute_process(
                COMMAND ${FIND_CMD}
                ARGUMENTS ${SP} "-regex" ".*dp_gea.*/toolchain\.cmake"
                OUTPUT_VARIABLE TC_FILE
                ERROR_VARIABLE FIND_ERR
            )
            if (NOT "${TC_FILE}" STREQUAL "")
                string(STRIP ${TC_FILE} TC_FILE)
                if(EXISTS ${TC_FILE})
                    set(CMAKE_TOOLCHAIN_FILE ${TC_FILE} CACHE FILEPATH "Path to toolchain file" FORCE)
                    include(${TC_FILE})
                endif()
                break()
            endif()
        endforeach()
    endif()
endfunction()

function(find_mviz)
    #find and set MVIZ automatically
    set(SEARCH_PATH "/home" "/root" "/opt" "/usr")
    foreach(SP ${SEARCH_PATH})
        execute_process(
            COMMAND ${FIND_CMD}
            ARGUMENTS ${SP} "-iname" "*MvizDevelKit.cmake"
            OUTPUT_VARIABLE MVIZ_FILE
            ERROR_VARIABLE FIND_ERR
        )
        if (NOT "${MVIZ_FILE}" STREQUAL "")
            string(STRIP ${MVIZ_FILE} MVIZ_FILE)
            if(EXISTS ${MVIZ_FILE})
                include(${MVIZ_FILE})
            endif()
            break()
        endif()
    endforeach()
    message(STATUS "MVIZ: ${MVIZ_FILE}")
endfunction()
