#pragma once

#include <memory>
#include <mutex>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <gst/gst.h>
#include <vector>
#include <boost/bind/bind.hpp>
#include <boost/signals2/signal.hpp>
#include "visualization/executable.h"
#include "ara/log/logging.h"

#define STREAMS 4
class DataIPC{
public:
    // virtual const std::vector<uint8_t>& GetData(uint8_t streamIndex) = 0;
    // boost::signals2::signal<void(std::vector<uint8_t>&, const uint8_t)> &DataReady() { return _dataReady;}
    boost::signals2::signal<void(GstBuffer*, const uint8_t)> &BufferReady() { return bufferReady;}
    virtual ~DataIPC(){}
protected:
    std::vector<uint8_t> _data[STREAMS];
    // boost::signals2::signal<void(std::vector<uint8_t>&, const uint8_t)> _dataReady;
    boost::signals2::signal<void(GstBuffer*, const uint8_t)> bufferReady;
};

class Subscriber : public DataIPC
{
private:
    using ProxySocA = jac::ap::visualization::proxy::VisualizationProxy;
    std::shared_ptr<ProxySocA> proxySocA_camera;
	std::mutex proxySocAMutex_camera;
    // std::mutex dataMutex;
    ara::com::FindServiceHandle handler;
    ara::log::Logger &log_{ara::log::CreateLogger("act", "cm dds event async client sample context",
													  ara::log::LogLevel::kVerbose)};
public:
    Subscriber();
    ~Subscriber();
    void availabilityCallback(ara::com::ServiceHandleContainer<ProxySocA::HandleType> handles,
												 ara::com::FindServiceHandle handler);
    void imageCallback();
    void stop();
    // const std::vector<uint8_t>& GetData(uint8_t streamIndex);
};



