#pragma once

#include "soup-server.h"
#include <vector>
#include <libsoup/soup.h>
#include <string>

class WebsocketServer;

class WebsocketServerListener {
public:
  virtual void onClientConnected(WebsocketServer *server, SoupWebsocketConnection *client, gushort index) {}
  virtual void onClientDisconnected(WebsocketServer *server, SoupWebsocketConnection *client, gushort index) {}
  virtual void onClientMessage(WebsocketServer *server, SoupWebsocketConnection *client, std::string& message, gushort index) {}
};

class WebsocketServer {
    private:
        GSocketAddress *addr;
        gushort port;
        SoupServer *server;
        std::vector<SoupWebsocketConnection *> clients;
        gushort _index;
        // SoupWebsocketConnection *currentConnection;
        WebsocketServerListener *_listener;
        GMainLoop *_loop;
    public:
        WebsocketServer(WebsocketServerListener *listener, gushort port, gushort index);
        static void onMessage(SoupWebsocketConnection *ws, SoupWebsocketDataType type, GBytes *message, gpointer userData);
        static void onClosing (SoupWebsocketConnection* connection, gpointer user_data);
        static void onClosed (SoupWebsocketConnection* connection, gpointer user_data);
        static void onIncommingConnection (SoupServer *server, SoupWebsocketConnection *connection, const char *path, SoupClientContext *client, gpointer user_data);
        void StartServer();
        void stopServer();
        void sendMessage(SoupWebsocketConnection *connection, std::string message);
        void sendMessageToAll(std::string message);
        gushort getIndex();
};